---
title: WebGLRenderingContext.polygonOffset()
slug: Web/API/WebGLRenderingContext/polygonOffset
tags:
  - API
  - Method
  - Reference
  - WebGL
  - WebGLRenderingContext
---
<div>{{APIRef("WebGL")}}</div>

<p>The <strong><code>WebGLRenderingContext.polygonOffset()</code></strong> method of the <a href="/en-US/docs/Web/API/WebGL_API">WebGL API</a> specifies the scale factors and units to calculate depth values.</p>

<p>The offset is added before the depth test is performed and before the value is written into the depth buffer.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">void <var>gl</var>.polygonOffset(<var>factor</var>, <var>units</var>);
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>factor</dt>
 <dd>A {{domxref("GLfloat")}} which sets the scale factor for the variable depth offset for each polygon. The default value is 0.</dd>
 <dt>units</dt>
 <dd>A {{domxref("GLfloat")}} which sets the multiplier by which an implementation-specific value is multiplied with to create a constant depth offset. The default value is 0.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>None.</p>

<h2 id="Examples">Examples</h2>

<p>The polygon offset fill is disabled by default. To enable or disable polygon offset fill, use the {{domxref("WebGLRenderingContext.enable", "enable()")}} and {{domxref("WebGLRenderingContext.disable", "disable()")}} methods with the argument <code>gl.POLYGON_OFFSET_FILL</code>.</p>

<pre class="brush: js">gl.enable(gl.POLYGON_OFFSET_FILL);
gl.polygonOffset(2, 3);
</pre>

<p>To check the current polygon offset factor or units, query the <code>POLYGON_OFFSET_FACTOR</code> and <code>POLYGON_OFFSET_UNITS</code> constants.</p>

<pre class="brush: js">gl.getParameter(gl.POLYGON_OFFSET_FACTOR); // 2
gl.getParameter(gl.POLYGON_OFFSET_UNITS);  // 3
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('WebGL', "#5.14.3", "polygonOffset")}}</td>
   <td>{{Spec2('WebGL')}}</td>
   <td>Initial definition.</td>
  </tr>
  <tr>
   <td>{{SpecName('OpenGL ES 2.0', "glPolygonOffset.xml", "glPolygonOffset")}}</td>
   <td>{{Spec2('OpenGL ES 2.0')}}</td>
   <td>Man page of the OpenGL API.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.WebGLRenderingContext.polygonOffset")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{domxref("WebGLRenderingContext.depthFunc()")}}</li>
</ul>
